unsigned int ntq_copy(const char *src, char *dst,
                int len, int sum, int *src_err_ptr, int *dst_err_ptr)
{
	char fpu_save[108];

	__asm__ __volatile__ (
		"	fsave	%0\n"
		"	fwait\n"
			: /* output */ "=m"(fpu_save[0]) 
	);

	int count = len/8;
	__asm__ __volatile__ (
		"	testl	%%ecx, %%ecx\n"	//carry unset - we need it
		// these two back-to-back references actually _is_ the fastest way
		"2:	movq	(%1), %%mm0\n"
		"	adcl	(%1), %%eax\n"
		"	adcl	4(%1), %%eax\n"
		"	movntq	%%mm0, (%2)\n"
		"	leal	8(%1), %1\n"
		"	leal	8(%2), %2\n"
		"	loop	2b\n"
		"	adcl	$0, %%eax\n"
			: /* output */	"=a" (sum)
			: /* input */	"r" (src), "r" (dst), "a" (sum), "c" (count)
			: /* clobber */	"bx", "memory"
	);
	__asm__ __volatile__ (
		//"	femms\n"
		"	sfence\n"
		"	frstor	%0\n"
			: : /* input */	"m" (fpu_save[0])
	);
	
	return sum;
}
