unsigned int ntqpf2_copy(const char *src, char *dst,
                int len, int sum, int *src_err_ptr, int *dst_err_ptr)
{
	char fpu_save[108];
	__asm__ __volatile__ (
		"	prefetchnta (%0)\n"
		"	prefetchnta 64(%0)\n"
		"	prefetchnta 128(%0)\n"
		"	prefetchnta 192(%0)\n"
			: : "r" (src) 
	);

	__asm__ __volatile__ (
		"	fsave	%0\n"
		"	fwait\n"
			: /* output */ "=m" (fpu_save[0]) 
	);

	int count = len/(8*8);
	while(count--)
 {
		__asm__ __volatile__ (
		"1:	prefetchnta 256(%1)\n"
		"	xorl	%%ecx, %%ecx\n"	//carry unset - we need it
		"	mov	$8, %%cl\n"
		"2:	mov	4(%1), %%ebx\n"
		"	adcl	%%ebx, %%eax\n"
		"	movd	%%ebx, %%mm0\n"		//move to low 32
		//or:"	pshufw	$0x40, %%mm0, %%mm0\n"	//copy low 32 to high 32, zero low 32
		"	psllq	$32, %%mm0\n"		//shift left 32 bits
		"	mov	(%1), %%ebx\n"
		"	adcl	%%ebx, %%eax\n"
		"	movd	%%ebx, %%mm0\n"		//move to low 32
		//BUG: somehow I end up with wrong mm0 contents...
		//POISON catches this, uncomment this:
		//"	movq	(%1), %%mm0\n"
		//and it works!
		//which suggests that all this register dance is not needed ;-)
		//(look into ntqpf_copy.c - and it's faster too!)
		"	movntq	%%mm0, (%2)\n"
		"	leal	8(%1), %1\n"
		"	leal	8(%2), %2\n"
		"	loop	2b\n"
		"	adcl	$0, %%eax\n"
			: /* output */	"=a" (sum)
			: /* input */	"r" (src), "r" (dst), "a" (sum)
			: /* clobber */	"bx", "cx", "memory"
		);
	}
	__asm__ __volatile__ (
		//"	femms\n"
		"	sfence\n"
		"	frstor	%0\n"
			: : /* input */	"m" (fpu_save[0])
	);
	
	return sum;
}
