unsigned int ntqpfm_copy(const char *src, char *dst,
                int len, int sum, int *src_err_ptr, int *dst_err_ptr)
{
	char mm0[8];
	__asm__ __volatile__ (
		"	prefetchnta (%0)\n"
		"	prefetchnta 64(%0)\n"
		"	prefetchnta 128(%0)\n"
		"	prefetchnta 192(%0)\n"
			: : "r" (src) 
	);

	__asm__ __volatile__ (
		"	movq	%%mm0, %0\n"
			: /* output */ "=m"(mm0[0]) 
	);

	int count = len/(8*8);
	while(count--)
 {
		__asm__ __volatile__ (
		"1:	prefetchnta 256(%1)\n"
		"	xorl	%%ecx, %%ecx\n"	//carry unset - we need it
		"	mov	$8, %%cl\n"
		"2:	movq	(%1), %%mm0\n"
		"	adcl	(%1), %%eax\n"
		"	adcl	4(%1), %%eax\n"
		"	movntq	%%mm0, (%2)\n"
		"	leal	8(%1), %1\n"
		"	leal	8(%2), %2\n"
		"	loop	2b\n"
		"	adcl	$0, %%eax\n"
			: /* output */	"=a" (sum)
			: /* input */	"r" (src), "r" (dst), "a" (sum)
			: /* clobber */	"bx", "cx", "memory"
		);
	}
	__asm__ __volatile__ (
		//"	femms\n"
		"	sfence\n"
		"	movq	%0, %%mm0\n"
			: : /* input */ "m"(mm0[0]) 
	);
	
	return sum;
}
