unsigned int pfm2_csum(const unsigned char *src, int len, unsigned int sum)
{
	char mm0[8];
	__asm__ __volatile__ (
		"	prefetchnta (%0)\n"
		"	prefetchnta 64(%0)\n"
		"	prefetchnta 128(%0)\n"
		"	prefetchnta 192(%0)\n"
			: : "r" (src) 
	);
	__asm__ __volatile__ (
		"	movq	%%mm0, %0\n"
			: /* output */ "=m"(mm0[0]) 
	);

	int count = len/(8*8);
	while(count--)
 {
		__asm__ __volatile__ (
		"1:	prefetchnta 256(%1)\n"
		"	xorl	%%ecx, %%ecx\n"	//carry unset - we need it
		"	mov	$4, %%cl\n"
		"2:	adcl	(%1), %%eax\n"
		"	adcl	4(%1), %%eax\n"
		"	adcl	8(%1), %%eax\n"
		"	adcl	12(%1), %%eax\n"
		"	leal	16(%1), %1\n"
		"	loop	2b\n"
		"	adcl	$0, %%eax\n"
			: /* output */	"=a" (sum)
			: /* input */	"r" (src), "a" (sum)
			: /* clobber */	"bx", "cx", "memory"
		);
	}
	__asm__ __volatile__ (
		//"	femms\n"
		"	sfence\n"
		"	movq	%0, %%mm0\n"
			: : /* input */ "m"(mm0[0]) 
	);
	
	return sum;
}
